<%@Language=VBScript%>
<% Option Explicit %>
<% Response.Expires = 0 %>
<% Response.AddHeader "PRAGMA", "NO-CACHE" %>

<!-- #Include file="../Common.ASP" -->
<%
Dim grsQues
Dim gQuesList
Dim gIsPost
Dim gQueType
Dim gFieldNewQuestion

gQueType = Request.QueryString("QueType")
gAppType = Request.Form("fSelectAppType")
If gAppType = "" Then
	gAppType = "1"
End If

Call ConnectToDB()
gIsAdmin = IsAdmin()

If gIsAdmin Then
	gAppTypesList = GetAppTypesList()

	gIsPost = Not IsEmpty(Request.Form("IsPost"))

	If Request.Form("IsPost") = "" Then
		gIsPost = False
	End If

	If gIsPost Then
		gFieldNewQuestion = Trim("" & Request.Form("fNewQuestion"))
		Call CopyQueList()
		Call PerformAction()
		Call UpdateRecord()
	End If
	Call GetQuesRS()
	WritePage()

	grsQues.close
	set grsQues = nothing

Else
	Response.Write ("You do not have access to this page.")
End If

gConn.close
set gConn = nothing
'*******************************************************************************
'
'*******************************************************************************
Sub WriteContent()

	If gQueType = "A" Then
		Response.Write "<B>Additional Information Questions Entry Form</B>"
	Else
		Response.Write "<B>Notes Questions Entry Form</B>"
	End If
	'-----------------------------------------------------------------
	' Input form
	'-----------------------------------------------------------------
	Response.Write "<form name=EditQues method=post" & vbCrLf _
				 & "      action=EditQuestions.asp?QueType=" & gQueType & ">" & vbCrLf
	
	'-----------------------------------------------------------------
	' Hidden field used by the server to detect POST operations.
	'-----------------------------------------------------------------
	Response.Write "<input type=hidden name=IsPost value=yes>" & vbCrLf
	Response.Write GetSelectHTML("fSelectAppType",gAppTypesList, gAppType,"1","Q")
	Call DisplayForm()
	Response.Write "</form>" & vbCrLf
End Sub
	
'*******************************************************************************
'
'*******************************************************************************
Sub DisplayForm()	
	Dim i
	
	Response.Write "<TABLE BORDER=1 class=""text"" Width=450 cellpadding=2 cellspacing=0>" & vbCrLf
	Response.Write "   <TR>" & vbCrLf
	Response.Write "      <TD valign=top>&nbsp;</TD>" & vbCrLf
	Response.Write "      <TD valign=top>Questions</TD>" & vbCrLf
	Response.Write "      <TD valign=top>Action</TD>" & vbCrLf
	Response.Write "   </TR>" & vbCrLf

	Response.Write "" & vbCrLf

	i=0
	Do Until grsQues.EOF
		i=i+1
		Response.Write "   <TR>" & vbCrLf
		'-------------------------------------------------------------
		' Column: Show Sequence Number
		'-------------------------------------------------------------
		Response.Write "      <TD valign=top>" & vbCrLf
		Response.Write "<font size=""2""><b>" & vbCrLf
		Response.Write Server.HTMLEncode("" & grsQues("QuestionSeqNO").Value) & vbCrLf
		Response.Write "</b></font>" & vbCrLf
		Response.Write "      </TD>" & vbCrLf

		Response.Write "      <TD valign=top>" & vbCrLf
		Response.Write "         <Textarea name=fQuestion" & i & " ROWS=5 COLS=50>" 
		Response.Write Server.HTMLEncode("" & grsQues("Question").Value)
		Response.Write "         </textarea>" & vbCrLf
		Response.Write "      </TD>" & vbCrLf

		'-------------------------------------------------------------
		' Column: Actions (promote, demote, delete)
		'-------------------------------------------------------------
		Response.Write "<td valign=top>" & vbCrLf
		Response.Write "<nobr>"
		Response.Write "<input tabindex=""-1"" name=fPromote" & i _
					 & " type=image src=../images/promote.gif title=Promote border=0>"
		Response.Write "<input tabindex=""-1"" name=fDemote" & i _
					 & " type=image src=../images/demote.gif title=Demote border=0>"
		Response.Write "<input tabindex=""-1"" name=fDelete" & i _
					 & " type=image src=../images/delete.gif title=Delete border=0>"
		Response.Write "</nobr></td>"

		Response.Write "   </TR>" & vbCrLf
		grsQues.MoveNext
	Loop
	'-------------------------------------------------------------
	' New Entry
	'-------------------------------------------------------------
	Response.Write "   <TR>" & vbCrLf
	Response.Write "      <TD valign=top><font size=""2""><b>New</b></font></TD>" & vbCrLf
	Response.Write "      <TD valign=top>" & vbCrLf
	Response.Write "         <Textarea name=fNewQuestion ROWS=5 COLS=50></textarea>" & vbCrLf
	Response.Write "      </TD>" & vbCrLf
	
	Response.Write "      <TD valign=top align=center><input name=fCommand type=submit value=Save></TD>" & vbCrLf
	
	Response.Write "</TABLE>"
End Sub

'*******************************************************************************
'
'*******************************************************************************
Sub GetQuesRS()
	Dim strSQL

	strSQL = " SELECT * FROM Questions Where AppType = '" & gAppType & "'"
	strSQL = strSQL & " and QueType = '" & gQueType & "'"
	strSQL = strSQL & " order by QuestionSeqNo"
	'Response.Write strSQL
	
	Set grsQues = CreateObject("ADODB.Recordset")
	grsQues.Open strSQL, gConn, adOpenForwardOnly, adLockReadOnly, adCmdText

End Sub

'*********************************************************************
'
'*********************************************************************
Sub CopyQueList()
	Dim FormField
	Dim Ques
	Dim QueID
	Dim i
	Dim HighNumber

	HighNumber = 0
	For Each FormField In Request.Form
		If Instr(FormField, "fQuestion") = 1 Then
			QueID = CLng(Mid(FormField, 10))
			If HighNumber < QueID Then
				HighNumber = QueID
			End If
		End If
	Next

	Set gQuesList = CreateObject("Scripting.Dictionary")
	For i = 1 To HighNumber
		Redim Ques(1)
		Ques(0) = "" & Request.Form("fQuestion" & i)
		gQuesList.Add i, Ques
	Next

End Sub

'*******************************************************************************
' Routine:		Performction
' Description:
'
' Notes:		<input type=image id=image1 name=image1> tags return x y coordinates
'				of the mouse click in these POST values:
'
'				fieldname.x
'				fieldname.y
'
'				In our case, were interested in the name of the field
'				which contains both the action type "fPromote",
'				"fDemote" or "fDelete" and the answer number.
'				Thus a returned fieldname would be something like
'				"fPromote3.x" or "fPromote3.y". Once we parse the
'				returned field name info for the action and answer
'				number, we then attempt to perform the action
'				here in memory. A later routine will then commit
'				our work to the database.
'*******************************************************************************
Sub PerformAction()
	Dim FormField
	Dim strAction
	Dim QueID
	Dim Pos
	Dim SrcKey
	Dim DestKey
	Dim CurrQue

	strAction = ""
	For Each FormField In Request.Form
		If Instr(FormField, "fPromote") = 1 Then
			strAction="fPromote"
			Exit For
		End If

		If Instr(FormField, "fDemote") = 1 Then
			strAction = "fDemote"
			Exit For
		End If

		If Instr(FormField, "fDelete") = 1 Then
			strAction = "fDelete"
			Exit For
		End If
	Next
	'-----------------------------------------------------------------
	' If we didn't find an action, get out.
	'-----------------------------------------------------------------
	If strAction = "" Then
		Exit Sub
	End If
	'-----------------------------------------------------------------
	' We found an action field in our post information.
	' Now found out which answer number it applies to.
	'-----------------------------------------------------------------
	FormField = Mid(FormField, Len(strAction) + 1)
	Pos = Instr(FormField, ".")
	FormField = Left(FormField, Pos - 1)
	QueID = CLng(FormField)
	'-----------------------------------------------------------------
	'
	'-----------------------------------------------------------------
	Select Case strAction
	Case "fPromote"
		If QueID > 1 Then
			SrcKey = QueID
			DestKey = QueID - 1
			gQuesList.Key(SrcKey) = "swap"
			gQuesList.Key(DestKey) = SrcKey
			gQuesList.Key("swap") = DestKey
		End If
	Case "fDemote"
		SrcKey = QueID
		DestKey = QueID + 1
		If gQuesList.Exists(DestKey) Then
			gQuesList.Key(SrcKey) = "swap"
			gQuesList.Key(DestKey) = SrcKey
			gQuesList.Key("swap") = DestKey
		End If
	Case "fDelete"
		CurrQue = QueID
		Do
			SrcKey = CurrQue + 1
			DestKey = CurrQue
			If gQuesList.Exists(SrcKey) Then
				gQuesList.Item(DestKey) = gQuesList.Item(SrcKey)
			Else
				gQuesList.Remove(DestKey)
				Exit Do
			End If
			QueID = QueID + 1
		Loop
	End Select
End Sub

'*********************************************************************
'
'*********************************************************************
Sub UpdateRecord()
	Dim strSQL
	Dim rsQues
	Dim Keys
	Dim i
	Dim Ques
	Dim QueID
	Dim strDate
	
	'Clear Database
	strSQL = "DELETE FROM Questions Where AppType = '" & gAppType & "'"
	strSQL = strSQL & " and QueType = '" & gQueType & "'"
	
	gConn.Execute strSQL

	'Open Recordset
	strSQL = " SELECT * FROM Questions Where AppType = '" & gAppType & "'"
	strSQL = strSQL & " and QueType = '" & gQueType & "'"
				
	Set rsQues = CreateObject("ADODB.Recordset")
	rsQues.Open strSQL, gConn, adOpenKeyset, adLockOptimistic, adCmdText

	Keys = gQuesList.Keys
	For i = 0 To gQuesList.Count - 1
		Ques = gQuesList.Item(Keys(i))
		QueID = Keys(i)
		rsQues.AddNew
		rsQues("QuestionSeqNO").Value = QueID
		rsQues("Question").Value = Left("" & Ques(0), rsQues("Question").DefinedSize)
		rsQues("AppType").Value = gAppType
		rsQues("QueType").Value = gQueType
		rsQues.Update
	Next

	If Len(gFieldNewQuestion) > 0 Then
		QueID = gQuesList.Count + 1
		rsQues.AddNew
		rsQues("QuestionSeqNO").value = QueID
		rsQues("Question").Value = Left(gFieldNewQuestion, rsQues("Question").DefinedSize)
		rsQues("AppType").Value = gAppType
		rsQues("QueType").Value = gQueType
		rsQues.Update
	End If

	rsQues.close
	set rsQues = nothing
End Sub

%>

