<%@Language=VBScript%>
<% Option Explicit %>
<% Response.Expires = 0 %>
<% Response.AddHeader "PRAGMA", "NO-CACHE" %>

<!-- #Include file="../Common.ASP" -->
<%
Dim gIsPost

Response.Buffer = True

gAppType = Request.QueryString("AppType")
gRefNo = Request.QueryString("RefNo")

Call ConnectToDB()
gIsAdmin = IsAdmin()
gIsExport = IsExport()
gFormName = GetFormName(gAppType)

gIsPost = Not IsEmpty(Request.Form("IsPost"))

gStateList = GetStateList()
gCountryList = GetCountryList()
gSubList = GetSubList()

Call GetAppRS()
gEndUserReadOnly = Submit2DC()
gAdminReadOnly = Submit2Govt()

If gIsPost Then
	Select Case Request.Form("Command")
		Case "Add"
			'To add a new record
			If grsApp.EOF and grsApp.BOF Then
				UpdateDatabase("new")
				call redirect("application.asp?AppType=" & gAppType & "&RefNo=" & Request.Form("fAppRefNo"))
			Else
				Response.Write "The reference number " & Request.Form("fAppRefNo") & " is already in the database"
			End If			
		Case "Update"
			'To update an existing record
			If grsApp.EOF and grsApp.BOF Then
				Response.Write "The reference number " & Request.Form("fAppRefNo") & " does not exist in the database"
			Else
				UpdateDatabase("")
				call redirect("application.asp?AppType=" & gAppType & "&RefNo=" & Request.Form("fAppRefNo"))
			End If
		Case "Modify"
			'To update an existing record
			If grsApp.EOF and grsApp.BOF Then
				Response.Write "The reference number " & Request.Form("fAppRefNo") & " does not exist in the database"
			Else
				UpdateDatabase("control")
				call redirect("application.asp?AppType=" & gAppType & "&RefNo=" & Request.Form("fAppRefNo"))
			End If		
	End Select
End If
WritePage()

grsApp.close
set grsApp = nothing
gConn.close
set gConn = nothing

'*******************************************************************************
'
'*******************************************************************************
Sub WriteContent()

Call GetStatusRS
Call GetSecStatusRS
Call GetApplicantRS
%>
<div id="object1" style="position:absolute; visibility:show; left:25px; top:-50px; z-index:2; ">layer hidden off the screen</div>
<B><% =gFormName %></B>
<FORM NAME="inputform" method=post action="application.asp?AppType=<%= gAppType%>" onsubmit="return validate();">
<input name=IsPost type=hidden value=IsPost>

<%	If ((NOT gIsAdmin) and (NOT gEndUserReadOnly)) OR (gIsAdmin and (NOT gAdminReadOnly)) Then %>
	<TABLE BORDER=0 class="text" cellpadding=4 cellspacing=0>
	<TR><TD><NOBR>For help in completing each item on this application form, click on the item to obtain an item specific help screen.</NOBR></TD></TR>
	</TABLE>
<%	End If %>

<%
	If gRefNO <> "" Then
		If gIsAdmin Then
			Call DisplayForm(true, gAdminReadOnly, true)
		Else
			Call DisplayForm(false, gEndUserReadOnly, true)
		End If
	Else
		Call DisplayForm(gIsAdmin, false, false)
	End If
%>

<center>
<%	'If (EndUser and Edit) OR (Admin and Edit) 
	If ((NOT gIsAdmin) and (NOT gEndUserReadOnly)) OR (gIsAdmin and (NOT gAdminReadOnly)) Then
		If gRefNO = "" Then %>
			<input name=command type=submit value=Add Title="<% =GetHelp("Add") %>">
<%		Else %>
			<NOBR>
				<input name=command type=button value="Additional Information" onclick="window.location.href='QA.asp?AppType=<%= gAppType%>&RefNo=<%= gRefNo%>&QueType=A'" Title="<% =GetHelp("Additional Information") %>">
				<input name=command type=button value="Notes" onclick="window.location.href='QA.asp?AppType=<%= gAppType%>&RefNo=<%= gRefNo%>&QueType=N'" Title="<% =GetHelp("Notes") %>">
				<input name=command type=button value="Additional End-users" onclick="window.location.href='enduser.asp?AppType=<%= gAppType%>&RefNo=<%= gRefNo%>'" Title="<% =GetHelp("Additional End-users") %>">
				<input name=command type=button value="Commodity" onclick="window.location.href='commodity.asp?AppType=<%= gAppType%>&RefNo=<%= gRefNo%>'" Title="<% =GetHelp("Commodity") %>">
			</NOBR>
			<BR>
			<input name=command type=submit value=Update Title="<% =GetHelp("Update") %>">
<%		End If %>

<%		If (NOT gIsAdmin) AND gRefNO <> "" Then %>
			<input name=command type=button value="Submit To Washington" onclick="window.location.href='submit2Washington.asp?AppType=<%= gAppType%>&RefNo=<%= gRefNo%>'">
<%		End If
	Else
		If gIsAdmin Then %>
			<input name=command type=submit value=Modify>
<%		End If
	End If %>
<input name=command type=button value="Back" onclick="window.location.href='applist.asp?AppType=<% = gAppType %>'">
</center>
</FORM>
<script language="JavaScript">
<!-- hide from non-script-enabled browsers
function validate () {
<%	If gRefNO = "" Then %>
	if (document.inputform.fAppRefNo.value == "") {
		alert ("Please enter a Reference Number.");
		document.inputform.fAppRefNo.select();
		document.inputform.fAppRefNo.focus();
		return false;
	}
	else {
		if (document.inputform.fAppRefNo.value.length != 9) {
			alert ("Reference Number must be 9 characters long.");
			document.inputform.fAppRefNo.select();
			document.inputform.fAppRefNo.focus();
			return false;	
		}
	}
<%	End If %>
	

	
return true;
}

function validateall() {
	var i=document.inputform.fSub.selectedIndex;
	if (document.inputform.fSub.options(i).text == "") {
		alert ("Please select a subsidiary.");
		document.inputform.fSub.focus();
		return false;
	}
	return true;
}
// stop hiding -->

</script>

<%
End Sub

'*******************************************************************************
'
'*******************************************************************************
Sub GetAppRS()
	Dim strSQL

	strSQL = " SELECT * from export " & _
	      " Where AppType = '" & gAppType & "'"

	If gRefNo <> "" Then
		strSQL = strSQL & " and AppRefNO = '" & gRefNo & "'"
	Else
		If gIsPost Then
			strSQL = strSQL & " and AppRefNO = '" & Request.Form("fAppRefNo") & "'"
		End If		
	End If
	
	Set grsApp = CreateObject("ADODB.Recordset")
	grsApp.Open strSQL, gConn, adOpenKeyset, adLockOptimistic, adCmdText

End Sub
'*******************************************************************************
'
'*******************************************************************************
Sub UpdatePerson(strType)

	If gIsAdmin Then
		grsApp(strType & "ID") = Request.Form("fID" & strType)		
	End If
	grsApp(strType & "Name") = Request.Form("fName" & strType)
	grsApp(strType & "Addr1") = Request.Form("fAddr1" & strType)
	grsApp(strType & "Addr2") = Request.Form("fAddr2" & strType)
	grsApp(strType & "City") = Request.Form("fCity" & strType)
	grsApp(strType & "PostalCD") = Request.Form("fPostalCode" & strType)
	
	If (strType = "App" or strType = "Other") Then
		grsApp(strType & "StateCD") = Request.Form("fState" & strType)
		
		If NOT gIsExport Then
			grsApp(strType & "CountryCD") = Request.Form("fCountryCD" & strType)
			grsApp(strType & "CountryName") = Request.Form("fCountry" & strType)
		End If
	Else
		grsApp(strType & "CountryCD") = Request.Form("fCountryCD" & strType)
		grsApp(strType & "CountryName") = Request.Form("fCountry" & strType)	
	End If
	
	If (strType = "App") Then
		grsApp(strType & "ID") = Request.Form("fID" & strType)
		grsApp("AppEmpID") = Request.Form("fEmpApp")
	Else
		grsApp(strType & "Phone") = Request.Form("fPhone" & strType)
	End If
End Sub
'*******************************************************************************
'
'*******************************************************************************
Sub UpdateDatabase(strMode)
	Dim strSQL
	
	If strMode = "new" Then
		grsApp.addnew
		grsApp("AppRefNo") = Request.Form("fAppRefNo")
		grsApp("AppType") = gAppType
		grsApp("CreateDate") = Date
	End If
	
	'If There is a status change
	If grsApp("AppStatus") <> Request.Form("fAppStatus") Then
		grsApp("AppStatus") = Request.Form("fAppStatus")
		If Request.Form("fAppStatus") = "IC" or Request.Form("fAppStatus")= "RI" Then
			grsApp("SubmitToGovtDate") = Date
		End If
		strSQL = "insert into ApplicationStatus values('" & gAppType & "','" & Request.Form("fAppRefNo") & "','" & date & "','" & Request.Form("fAppStatus") & "')"
		gConn.Execute strSQL
	End If
			
	If strMode = "control" Then
		grsApp("CaseNO") = Request.Form("fCaseNo")
		grsApp("CaseDate") = Request.Form("fCaseDate")
		grsApp("LicenseNO") = Request.Form("fLicenseNo")
		grsApp("LicenseDate") = Request.Form("fLicenseDate")
		grsApp("ExpirationDate") = Request.Form("fExpDate")
		grsApp("SecondaryStatusCD") = Request.Form("fSecStatus")
	Else
			grsApp("SubsidiaryCD") = Request.Form("fSub")
			grsApp("subBXA711") = Request.Form("fsubBXA")
			grsApp("subCertificate") = Request.Form("fsubImport")
			grsApp("subTechSpecs") = Request.Form("fsubTech")
			grsApp("subNuclearCert") = Request.Form("fsubNuclear")
			grsApp("subExpLetter") = Request.Form("fsubLetter")
			grsApp("subForeignAvailable") = Request.Form("fsubForeign")
			grsApp("subOther") = Request.Form("fsubOther")

			grsApp("SP_NDAA") = Request.Form("fspNDAA")
			grsApp("SP_Nuclear") = Request.Form("fspNuclear")
			grsApp("SP_Temp") = Request.Form("fspTemp")
			grsApp("SP_NA") = Request.Form("fspNA")
			grsApp("SP_Other") = Request.Form("fspOther")
			grsApp("Resubmission") = Request.Form("fReSub")
			grsApp("CertCountry") = Request.Form("fCertCountry")
			grsApp("CertNO") = Request.Form("fCertNO")
			
			UpdatePerson("App")
			UpdatePerson("Other")
			UpdatePerson("Purchaser")
			UpdatePerson("Inter")
			UpdatePerson("Ultimate")
			
			If NOT gIsExport Then
				UpdatePerson("Original")
			End If
			
			grsApp("SpecificEndUse") = Request.Form("fSpecificEndUse")
			
			If gIsAdmin Then
				grsApp("ContactPerson") = Request.Form("fContactPerson")
				grsApp("ContactPhone") = Request.Form("fContactPhone")
				grsApp("ContactFax") = Request.Form("fContactFax")
				grsApp("FileBXA711") = Request.Form("ffileBXA")
				grsApp("FileAssurance") = Request.Form("ffileAssurance")
				grsApp("FileCertificate") = Request.Form("ffileImport")
				grsApp("FileOther") = Request.Form("ffileOther")
				grsApp("ResubAppControlNO") = Request.Form("fresubControl")
				grsApp("ReplacementLicNO") = Request.Form("freplaceLicNo")
				grsApp("LicExceptSym") = Request.Form("fExceptionSym")
			End If
			grsApp("LastModifiedDate") = Date
			grsApp("LastModifiedBy") = Request.ServerVariables("LOGON_USER")
	End If
	grsApp.update
End Sub
%>