<%@Language=VBScript%>
<% Option Explicit %>
<% Response.Expires = 0 %>
<% Response.AddHeader "PRAGMA", "NO-CACHE" %>

<!-- #Include file="../Common.ASP" -->
<%
Dim grsList
Dim gList
Dim gIsPost
Dim gListCD
Dim gListType
Dim gListName

Dim gFieldNewCode
Dim gFieldNewName

Call ConnectToDB()
gIsAdmin = IsAdmin()

If gIsAdmin Then
	gListType = Request.QueryString("ListType")
	If gListType = "C" Then
		gListName = "Country"
	End If
	If gListType = "S" Then
		gListName = "State"
	End If
	
	gIsPost = Not IsEmpty(Request.Form("IsPost"))

	If gIsPost Then
		If fCommand = "Save" Then
			gFieldNewCode = Trim("" & Request.Form("fNewCode"))
			gFieldNewName = Trim("" & Request.Form("fNewName"))
			Call UpdateRecord()
		Else
			Call GetDeleteID()
		End If
	End If
	Call GetListRS()
	WritePage()

	grsList.close
	set grsList = nothing
Else
	Response.Write ("You do not have access to this page.")
End If

gConn.close
set gConn = nothing
'*******************************************************************************
'
'*******************************************************************************
Sub WriteContent()

	Response.Write "<B>" & gListName & "</B>" & vbCrLf
	
	'-----------------------------------------------------------------
	' Input form
	'-----------------------------------------------------------------
	Response.Write "<form name=EditList method=post" & vbCrLf _
				 & "      action=EditList.asp>" & vbCrLf
	
	'-----------------------------------------------------------------
	' Hidden field used by the server to detect POST operations.
	'-----------------------------------------------------------------
	Response.Write "<input type=hidden name=IsPost value=yes>" & vbCrLf
	Call DisplayForm()
	Response.Write "</form>" & vbCrLf
End Sub
	
'*******************************************************************************
'
'*******************************************************************************
Sub DisplayForm()	
	Dim i

	Response.Write "<TABLE BORDER=1 class=""text"" Width=450 cellpadding=2 cellspacing=0>" & vbCrLf
	Response.Write "   <TR>" & vbCrLf
	Response.Write "      <TD valign=top>&nbsp;</TD>" & vbCrLf
	Response.Write "      <TD valign=top>" & gListName & " Code</TD>" & vbCrLf
	Response.Write "      <TD valign=top>" & gListName & "</TD>" & vbCrLf
	Response.Write "      <TD valign=top>Action</TD>" & vbCrLf
	Response.Write "   </TR>" & vbCrLf

	Response.Write "" & vbCrLf

	i=0
	Do Until grsList.EOF
		i=i+1
		Response.Write "   <TR>" & vbCrLf
		'-------------------------------------------------------------
		' Column: Show Sequence Number
		'-------------------------------------------------------------
		Response.Write "      <TD valign=top>" & vbCrLf
		Response.Write "<font size=""2""><b>" & vbCrLf
		Response.Write i & vbCrLf
		Response.Write "</b></font>" & vbCrLf
		Response.Write "      </TD>" & vbCrLf

		Response.Write "      <TD valign=top>" & vbCrLf
		Response.Write "         <input type=Text name=fCode" & i & " maxLength=" & grsList("CountryStateCD").DefinedSize & " size=2 value="""
		Response.Write Server.HTMLEncode("" & grsList("CountryStateCD").Value) & """>"
		Response.Write "      </TD>" & vbCrLf

		Response.Write "      <TD>" & vbCrLf
		Response.Write "         <input type=Text name=fName" & i & " maxLength=" & grsList("CountryState").DefinedSize & " size=35 value="""
		Response.Write Server.HTMLEncode("" & grsList("CountryState").Value) & """>"
		Response.Write "      </TD>" & vbCrLf
		
		'-------------------------------------------------------------
		' Column: Actions (delete)
		'-------------------------------------------------------------
		Response.Write "<td valign=top>" & vbCrLf
		Response.Write "<nobr>"
		Response.Write "<input tabindex=""-1"" name=fDelete" & i _
					 & " type=image src=../images/delete.gif title=Delete border=0>"
		Response.Write "</nobr></td>"

		Response.Write "   </TR>" & vbCrLf
		grsList.MoveNext
	Loop
	'-------------------------------------------------------------
	' New Entry
	'-------------------------------------------------------------
	Response.Write "   <TR>" & vbCrLf
	Response.Write "      <TD valign=top><font size=""2""><b>New</b></font></TD>" & vbCrLf
	Response.Write "      <TD valign=top>" & vbCrLf
	Response.Write "         <input type=Text name=fNewCode maxLength=" & grsList("CountryStateCD").DefinedSize & " size=2 value="""">" & vbCrLf
	Response.Write "      </TD>" & vbCrLf

	Response.Write "      <TD>" & vbCrLf
	Response.Write "         <input type=Text name=fNewName maxLength=" & grsList("CountryState").DefinedSize & " size=35 value="""">" & vbCrLf
	Response.Write "      </TD>" & vbCrLf
	
	Response.Write "      <TD valign=center align=center><input name=fCommand type=submit value=Save></TD>" & vbCrLf
	
	Response.Write "</TABLE>"
End Sub

'*******************************************************************************
'
'*******************************************************************************
Sub GetListRS()
	Dim strSQL

	If gListType = "S" Then
        strSQL = " SELECT * from CountryState" & _
                 " Where CountryORState = 'S' order by CountryStateCD"
	End If
	
	If gListType = "C" Then
        strSQL = " SELECT * from CountryState" & _
                 " Where CountryORState = 'C' order by CountryState"
	End If
	
	Set grsList = CreateObject("ADODB.Recordset")
	grsList.Open strSQL, gConn, adOpenKeyset, adLockOptimistic, adCmdText

End Sub

'*******************************************************************************
' Routine:		GetDeleteID
' Description:
'
' Notes:		<input type=image id=image1 name=image1> tags return x y coordinates
'				of the mouse click in these POST values:
'
'				fieldname.x
'				fieldname.y
'
'				In our case, were interested in the name of the field
'				which contains both the action type "fDelete" and the answer number.
'				Thus a returned fieldname would be something like
'				"fDelete3.x" or "fDelete3.y". Once we parse the
'				returned field name info for the action and answer
'				number, we then attempt to perform the action
'				here in memory. A later routine will then commit
'				our work to the database.
'*******************************************************************************
Sub GetDeleteID()
	Dim FormField
	Dim strAction
	
	For Each FormField In Request.Form
		If Instr(FormField, "fDelete") = 1 Then
			strAction = "fDelete"
			Exit For
		End If
	Next
	'-----------------------------------------------------------------
	' If we didn't find an action, get out.
	'-----------------------------------------------------------------
	If strAction = "" Then
		gListCD = ""
		Exit Sub
	End If
	'-----------------------------------------------------------------
	' We found an action field in our post information.
	' Now found out which answer number it applies to.
	'-----------------------------------------------------------------
	FormField = Mid(FormField, Len(strAction) + 1)
	Pos = Instr(FormField, ".")
	FormField = Left(FormField, Pos - 1)
	gListCD = Request.Form("fCode" & CLng(FormField))
	
End Sub

'*********************************************************************
'
'*********************************************************************
Sub UpdateRecord()

	If gListCD <> "" Then
		strSQL = "DELETE FROM CountryState Where CountryStateCD = '" & _
			gListCD & "' and CountryOrState = '" & gListType & "'"
		gConn.Execute strSQL
	Else
		If Len(gFieldNewCode) > 0 and Len(gFieldNewName) > 0 Then
			grsList.AddNew
			grsList("CountryStateCD") = Left(gFieldNewCode, grsList("CountryStateCD").DefinedSize)
			grsList("CountryState") = Left(gFieldNewName, grsList("CountryState").DefinedSize)
			grsList("CountryOrState") = gListType
			grsList.Update
		End If
	End If

End Sub
%>

