<%@Language=VBScript%>
<% Option Explicit %>
<% Response.Expires = 0 %>
<% Response.AddHeader "PRAGMA", "NO-CACHE" %>

<!-- #Include file="../Common.ASP" -->
<%
Dim grsQues
Dim grsQA
Dim gIsPost
Dim gTotal
Dim gQueType

gQueType = Request.QueryString("QueType")
gAppType = Request.QueryString("AppType")
gRefNo = Request.QueryString("RefNo")

Call ConnectToDB()
gIsAdmin = IsAdmin()
gFormName = GetFormName(gAppType)

gIsPost = Not IsEmpty(Request.Form("IsPost"))

If gIsPost Then
	gTotal = Request.Form("fTotalQuestions")
	If Request.Form("fCommand") = "Save" Then
		Call UpdateRecord()
	End If
End If
Call GetQuesRS()
Call GetQARS()
WritePage()

grsQues.close
set grsQues = nothing
grsQA.close
set grsQA = nothing
gConn.close
set gConn = nothing
'*******************************************************************************
'
'*******************************************************************************
Sub WriteContent()

	'-----------------------------------------------------------------
	' Input form
	'-----------------------------------------------------------------
	If gQueType = "A" Then
		Response.Write "<B>Additional Information Entry Form</B><BR>" & vbCrLf
	End If
	If gQueType = "N" Then
		Response.Write "<B>Notes Entry Form</B><BR>" & vbCrLf
	End If	
	Response.Write "<B>" & gFormName & " Reference Number " & gRefno & "</B>" & vbCrLf
	
	Response.Write "<form name=EditQA method=post" & vbCrLf _
				 & "      action=QA.asp?AppType=" & gAppType & "&RefNo=" & gRefno & "&QueType=" & gQueType & ">" & vbCrLf
	
	'-----------------------------------------------------------------
	' Hidden field used by the server to detect POST operations.
	'-----------------------------------------------------------------
	Response.Write "<input type=hidden name=IsPost value=yes>" & vbCrLf
	Response.Write "<TABLE BORDER=1 class=""text"" Width=450 cellpadding=2 cellspacing=0>" & vbCrLf
	
	If grsQA.EOF and grsQA.BOF Then
		'If inputing new Then
		Call DisplayForm(True)
	Else
		Call DisplayForm(False)
	End If
	
	Response.Write "</TABLE>"
	Response.Write "<center>" & vbCrLf
	Response.Write "<input name=fCommand type=submit value=Save>" & vbCrLf
	Response.Write "<input name=fCommand type=button value=Back " & _
		"onclick=""window.location.href='application.asp?AppType=" & gAppType & _
		"&RefNo=" & gRefNo & "'"">" & vbCrLf
	Response.Write "</center>" & vbCrLf
	Response.Write "</form>" & vbCrLf
End Sub
	
'*******************************************************************************
'
'*******************************************************************************
Sub DisplayForm(IsNew)	
	Dim i
	Dim rsTemp
	
	If IsNew Then
		Set rsTemp = grsQues
	Else
		Set rsTemp = grsQA
	End If
	
	i=0
	Do Until rsTemp.EOF
		i=i+1
		Response.Write "<TR>" & vbCrLf
		'-------------------------------------------------------------
		' Column: Show Sequence Number
		'-------------------------------------------------------------
		Response.Write "      <TD valign=top>" & vbCrLf
		Response.Write "<font size=""2""><b>" & vbCrLf
		Response.Write Server.HTMLEncode("" & rsTemp("QuestionSeqNO").Value) & vbCrLf
		Response.Write "</b></font>" & vbCrLf
		Response.Write "      </TD>" & vbCrLf
			
		'-------------------------------------------------------------
		' Column: Show Question
		'-------------------------------------------------------------
		Response.Write "      <TD valign=top>" & vbCrLf
		Response.Write "" & rsTemp("Question").Value
		Response.Write "<Input name=fQuestion" & i & " type=hidden value="""
		Response.Write Server.HTMLEncode("" & rsTemp("Question").Value)
		Response.Write """>" & vbCrLf
		
		Response.Write "	  <BR>" & vbCrLf
		'-------------------------------------------------------------
		' Column: Show Answer
		'-------------------------------------------------------------
		Response.Write "<font face=""courier new, courier, sans-serif"">" & vbcrlf
		Response.Write "<textarea name=fAnswer" & i & " rows=5 cols=55>"
		If NOT IsNew Then
			Response.Write Server.HTMLEncode("" & rsTemp("Answer").Value)
		End If
		Response.Write "</textarea>"
		Response.Write "</font>" & vbCrLf
		Response.Write "</TD></TR>" & vbCrLf
		
		rsTemp.MoveNext
	Loop
	Response.Write "<Input name=fTotalQuestions type=hidden value=""" & i & """>" & vbCrLf
End Sub

'*******************************************************************************
'
'*******************************************************************************
Sub GetQuesRS()
	Dim strSQL

	strSQL = " SELECT * FROM Questions Where AppType = '" & gAppType & "'"
	strSQL = strSQL & " and QueType = '" & gQueType & "'"
	strSQL = strSQL & " order by QuestionSeqNo"
	'Response.Write strSQL
	
	Set grsQues = CreateObject("ADODB.Recordset")
	grsQues.Open strSQL, gConn, adOpenForwardOnly, adLockReadOnly, adCmdText

End Sub

'*******************************************************************************
'
'*******************************************************************************
Sub GetQARS()
	Dim strSQL

	strSQL = " SELECT * FROM QA " & _
		"Where AppRefNO = '" & gRefNo & "' " & _
		" and AppType = '" & gAppType & "' " & _
		" and QueType = '" & gQueType & "' " & _
		"order by QuestionSeqNo"
		
	'Response.Write strSQL
	
	Set grsQA = CreateObject("ADODB.Recordset")
	grsQA.Open strSQL, gConn, adOpenForwardOnly, adLockReadOnly, adCmdText

End Sub

'*********************************************************************
'
'*********************************************************************
Sub UpdateRecord()
	Dim strSQL
	Dim rsQA
	Dim Keys
	Dim i
	Dim Ques
	Dim QueID
	Dim strDate
	
	'Clear Database
	strSQL = "DELETE FROM QA " & _
		"Where AppRefNO = '" & gRefNo & "' and AppType = '" & gAppType & "' "
	strSQL = strSQL & " and QueType = '" & gQueType & "'"		
	gConn.Execute strSQL

	'Open Recordset
	strSQL = " SELECT * FROM QA " & _
		"Where AppRefNO = '" & gRefNo & "' and AppType = '" & gAppType & "' "
	strSQL = strSQL & " and QueType = '" & gQueType & "'"		
	Set rsQA = CreateObject("ADODB.Recordset")
	rsQA.Open strSQL, gConn, adOpenKeyset, adLockOptimistic, adCmdText

	For i = 1 to gTotal
		rsQA.AddNew
		rsQA("AppType").Value = gAppType
		rsQA("QueType").Value = gQueType
		rsQA("AppRefNo").Value = gRefNo
		rsQA("QuestionSeqNO").Value = i
		rsQA("Question").Value = Left("" & Request.Form("fQuestion" & i), rsQA("Question").DefinedSize)
		rsQA("Answer").Value = Left("" & Request.Form("fAnswer" & i), rsQA("Answer").DefinedSize)
		rsQA.Update
	Next

	rsQA.close
	set rsQA = nothing
End Sub

%>

